> For the complete documentation index, see [llms.txt](https://docs.yemreak.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.yemreak.com/arsiv/programming/expect-to-throw-with-typescript-using-buntest---ts2348.md).

# Expect to throw with Typescript using Bun:test - ts(2348)

typescript, bunjs

![2731804.png](https://i.imgur.com/1gYhX55.png)

## Basic Example

* Be careful on `() =>`

```javascript
// someFunction.ts
export function someFunction(shouldThrow: boolean): void {
	if (shouldThrow) {
		throw new Error("I am an error!")
	}
}

// someFunction.test.ts
import { someFunction } from "./someFunction"

test("should throw an error", () => {
	expect(() => someFunction(true)).toThrow("I am an error!")
})

test("should not throw an error", () => {
	expect(() => someFunction(false)).not.toThrow()
})
```

## Async Example

* Use `rejects` for `Promise`

```typescript
it("should return NotFoundError", () => {
	expect(getUserData("nonexistentUserId")).rejects.toBeInstanceOf(NotFoundError)
})
```

## Advanced Usage with Custom Error Types

* Use `new CustomError()` instead `CustomError` to prevent warning
* Be careful on `() =>`

```javascript
// CustomError.ts
export class CustomError extends Error {
	constructor(message: string) {
		super(message)
		Object.setPrototypeOf(this, CustomError.prototype)
	}
}

// someFunction.ts
import { CustomError } from "./CustomError"

export function someFunction(shouldThrow: boolean): void {
	if (shouldThrow) {
		throw new CustomError("I am a custom error!")
	}
}

// someFunction.test.ts
import { someFunction } from "./someFunction"
import { CustomError } from "./CustomError"

test("should throw a custom error", () => {
	expect(() => someFunction(true)).toThrow(new CustomError())
	// Use `new CustomError()` instead `CustomError` to prevent warning
	// Be careful on `() =>`
})
```

## Value of type "typeof X' is not callable. Did you mean to include 'new'? ts(2348)

* To prevent the error shown (it can run as expected) use `new AlreadyAdjusted()`

```javascript
export class AlreadyAdjusted extends Error {
	constructor() {
		super("Already adjusted")
	}
}
```

![jRe9NPT.png](https://i.imgur.com/jRe9NPT.png)

![6tNPvSi.png](https://i.imgur.com/6tNPvSi.png)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.yemreak.com/arsiv/programming/expect-to-throw-with-typescript-using-buntest---ts2348.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
